/*
 * SPI.h
 *
 * Created: 4/19/2014 8:15:45 PM
 *  Author: Daniel
 */ 


#ifndef SPI_H_
#define SPI_H_


uint8_t SPItransmitting = 0;

void SPIstart(void)
{
	DDRB |= _BV(SS) | _BV(SCLK) | _BV(MOSI); //outputs, SS cant be input
	SPCR = /*_BV(SPIE) |*/ _BV(SPE) | _BV(MSTR) | _BV(CPOL) ; //enable spi master, phase 1
	SPSR &= ~_BV(SPI2X); //double speed
}

inline void SPIfast(void)
{
	SPCR &= ~( _BV(SPR0) | _BV(SPI2X) );
}

inline void SPIslow(void)
{
	SPCR |= _BV(SPR0) | _BV(SPI2X);
}

uint8_t SPItransfer(uint8_t spidata)
{
	SPItransmitting = 1;
	SPDR = spidata;
	while (!(SPSR & _BV(SPIF)))
	;
	SPItransmitting = 0;
	return SPDR;
}



#endif /* SPI_H_ */